# coding: utf-8

"""
    Cisco Security Cloud Control Firewall Manager API

    Use the documentation to explore the endpoints Security Cloud Control Firewall Manager has to offer

    The version of the OpenAPI document: 1.13.0
    Contact: cdo.tac@cisco.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class DeviceEndOfLifeDetails(BaseModel):
    """
    End-of-Life details, including key EOL dates and links to official vendor notices.
    """ # noqa: E501
    end_of_life_announcement_date: Optional[datetime] = Field(default=None, description="The date (UTC; represented using the RFC-3339 standard), the hardware End-Of_life was announced", alias="endOfLifeAnnouncementDate")
    end_of_sale_date: Optional[datetime] = Field(default=None, description="The date (UTC; represented using the RFC-3339 standard), the hardware is eligible for sale.", alias="endOfSaleDate")
    last_date_of_support: Optional[datetime] = Field(default=None, description="The date (UTC; represented using the RFC-3339 standard), the hardware is eligible for support.", alias="lastDateOfSupport")
    url: Optional[StrictStr] = Field(default=None, description="The hardware End-Of-Life notice URL with more information on the End-Of-Life details.")
    __properties: ClassVar[List[str]] = ["endOfLifeAnnouncementDate", "endOfSaleDate", "lastDateOfSupport", "url"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DeviceEndOfLifeDetails from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DeviceEndOfLifeDetails from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "endOfLifeAnnouncementDate": obj.get("endOfLifeAnnouncementDate"),
            "endOfSaleDate": obj.get("endOfSaleDate"),
            "lastDateOfSupport": obj.get("lastDateOfSupport"),
            "url": obj.get("url")
        })
        return _obj


